searchData={"items":[{"type":"module","title":"Ueberauth.Strategy.Bexio","doc":"Bexio Strategy for Überauth.","ref":"Ueberauth.Strategy.Bexio.html"},{"type":"function","title":"Ueberauth.Strategy.Bexio.credentials/1","doc":"Includes the credentials from the bexio response.","ref":"Ueberauth.Strategy.Bexio.html#credentials/1"},{"type":"function","title":"Ueberauth.Strategy.Bexio.default_options/0","doc":"","ref":"Ueberauth.Strategy.Bexio.html#default_options/0"},{"type":"function","title":"Ueberauth.Strategy.Bexio.extra/1","doc":"Stores the raw information (including the token) obtained from the bexio callback.","ref":"Ueberauth.Strategy.Bexio.html#extra/1"},{"type":"function","title":"Ueberauth.Strategy.Bexio.handle_request!/1","doc":"Handles initial request for Bexio authentication.\n\nTo customize the scope (permissions) that are requested by bexio include them as part of your url:\n\n    \"/auth/bexio?scope=api read_user read_registry\"\n\nThe request will include the state parameter that was set by ueberauth (if available)","ref":"Ueberauth.Strategy.Bexio.html#handle_request!/1"},{"type":"function","title":"Ueberauth.Strategy.Bexio.info/1","doc":"Fetches the fields to populate the info section of the `Ueberauth.Auth` struct.","ref":"Ueberauth.Strategy.Bexio.html#info/1"},{"type":"function","title":"Ueberauth.Strategy.Bexio.uid/1","doc":"Fetches the uid field from the JWT payload","ref":"Ueberauth.Strategy.Bexio.html#uid/1"},{"type":"module","title":"Ueberauth.Strategy.Bexio.BexioJwt","doc":"This will parse and handle the JWT payload from the OAuth2 response.","ref":"Ueberauth.Strategy.Bexio.BexioJwt.html"},{"type":"function","title":"Ueberauth.Strategy.Bexio.BexioJwt.parse_jwt_payload/1","doc":"","ref":"Ueberauth.Strategy.Bexio.BexioJwt.html#parse_jwt_payload/1"},{"type":"module","title":"Ueberauth.Strategy.Bexio.OAuth","doc":"OAuth2 for Bexio.\n\nAdd `client_id` and `client_secret` to your configuration:\n\n    config :ueberauth, Ueberauth.Strategy.Bexio.OAuth,\n      client_id: System.get_env(\"BEXIO_CLIENT_ID\"),\n      client_secret: System.get_env(\"BEXIO_CLIENT_SECRET\")","ref":"Ueberauth.Strategy.Bexio.OAuth.html"},{"type":"function","title":"Ueberauth.Strategy.Bexio.OAuth.authorize_url/2","doc":"","ref":"Ueberauth.Strategy.Bexio.OAuth.html#authorize_url/2"},{"type":"function","title":"Ueberauth.Strategy.Bexio.OAuth.authorize_url!/2","doc":"Provides the authorize url for the request phase of Ueberauth. No need to call this usually.","ref":"Ueberauth.Strategy.Bexio.OAuth.html#authorize_url!/2"},{"type":"function","title":"Ueberauth.Strategy.Bexio.OAuth.client/1","doc":"Construct a client for requests to Bexio.\n\nThis will be setup automatically for you in `Ueberauth.Strategy.Bexio`.\n\nThese options are only useful for usage outside the normal callback phase of Ueberauth.","ref":"Ueberauth.Strategy.Bexio.OAuth.html#client/1"},{"type":"function","title":"Ueberauth.Strategy.Bexio.OAuth.get/4","doc":"","ref":"Ueberauth.Strategy.Bexio.OAuth.html#get/4"},{"type":"function","title":"Ueberauth.Strategy.Bexio.OAuth.get_access_token/2","doc":"","ref":"Ueberauth.Strategy.Bexio.OAuth.html#get_access_token/2"},{"type":"function","title":"Ueberauth.Strategy.Bexio.OAuth.get_token/3","doc":"","ref":"Ueberauth.Strategy.Bexio.OAuth.html#get_token/3"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n## (Unreleased)","ref":"changelog.html"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"- Further adaption to the new endpoint logic\n- `company_profile` in default scopes to keep with current logic","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"- Updated the OAuth2 logic from idp to the new auth endpoint.","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.6 - Changelog","doc":"- Bugfix SSL\n- Adding dialyzer and credo","ref":"changelog.html#v0-1-6"},{"type":"extras","title":"v0.1.5 - Changelog","doc":"- Bugfix Naming","ref":"changelog.html#v0-1-5"},{"type":"extras","title":"v0.1.4 - Changelog","doc":"- Added company id and login id to the raw user info under extra","ref":"changelog.html#v0-1-4"},{"type":"extras","title":"v0.1.3 - Changelog","doc":"- Adding company id","ref":"changelog.html#v0-1-3"},{"type":"extras","title":"v0.1.2 - Changelog","doc":"- Adding parsed JWT token to raw info because company_id and login_id combined are unique","ref":"changelog.html#v0-1-2"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"- Pipeline Test","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"- Initial Release","ref":"changelog.html#v0-1-0"},{"type":"extras","title":"Contributing","doc":"# Contributing","ref":"contributing.html"},{"type":"extras","title":"Pull Requests Welcome - Contributing","doc":"1. Fork ueberauth_bexio\n2. Create a topic branch\n3. Make logically-grouped commits with clear commit messages\n4. Push commits to your fork\n5. Open a pull request against ueberauth_bexio/master","ref":"contributing.html#pull-requests-welcome"},{"type":"extras","title":"Issues - Contributing","doc":"If you believe there to be a bug, please provide the maintainers with enough\ndetail to reproduce or a link to an app exhibiting unexpected behavior.","ref":"contributing.html#issues"},{"type":"extras","title":"Überauth Bexio","doc":"# Überauth Bexio\n\n[![Continuous Integration](https://github.com/smart-software-engineering/ueberauth_bexio/actions/workflows/elixir.yml/badge.svg)](https://github.com/smart-software-engineering/ueberauth_bexio/actions/workflows/elixir.yml/badge.svg)\n[![Module Version](https://img.shields.io/hexpm/v/ueberauth_bexio.svg)](https://hex.pm/packages/ueberauth_bexio)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ueberauth_bexio/)\n[![Total Download](https://img.shields.io/hexpm/dt/ueberauth_bexio.svg)](https://hex.pm/packages/ueberauth_bexio)\n[![License](https://img.shields.io/hexpm/l/ueberauth_bexio.svg)](https://github.com/ueberauth/ueberauth_bexio/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/smart-software-engineering/ueberauth_bexio.svg)](https://github.com/smart-software-engineering/ueberauth_bexio/commits/master)\n\n\n> Bexio OAuth2 strategy for Überauth.","ref":"readme.html"},{"type":"extras","title":"Installation - Überauth Bexio","doc":"1.  Setup your application at [Bexio Developer](https://developer.bexio.com/).\n\n2.  Add `:ueberauth_bexio` to your list of dependencies in `mix.exs`:\n\n    ```elixir\n    def deps do\n      [\n        {:ueberauth_bexio, \"~> 0.2.1\"}\n      ]\n    end\n    ```\n\n3.  Add Bexio to your Überauth configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth,\n      providers: [\n        bexio: {Ueberauth.Strategy.Bexio, []}\n      ]\n    ```\n\n4.  Update your provider configuration:\n\n    Use that if you want to read client ID/secret from the environment\n    variables in the compile time:\n\n    ```elixir\n    config :ueberauth, Ueberauth.Strategy.Bexio.OAuth,\n      client_id: System.get_env(\"BEXIO_CLIENT_ID\"),\n      client_secret: System.get_env(\"BEXIO_CLIENT_SECRET\")\n    ```\n\n    Use that if you want to read client ID/secret from the environment\n    variables in the run time:\n\n    ```elixir\n    config :ueberauth, Ueberauth.Strategy.Bexio.OAuth,\n      client_id: {System, :get_env, [\"BEXIO_CLIENT_ID\"]},\n      client_secret: {System, :get_env, [\"BEXIO_CLIENT_SECRET\"]}\n    ```\n\n5.  Include the Überauth plug in your controller:\n\n    ```elixir\n    defmodule MyApp.AuthController do\n      use MyApp.Web, :controller\n      plug Ueberauth\n      ...\n    end\n    ```\n\n6.  Create the request and callback routes if you haven't already:\n\n    ```elixir\n    scope \"/auth\", MyApp do\n      pipe_through :browser\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n    ```\n\n7.  Your controller needs to implement callbacks to deal with `Ueberauth.Auth` and `Ueberauth.Failure` responses.\n\nFor an example implementation see the [Überauth Example](https://github.com/ueberauth/ueberauth_example) application.","ref":"readme.html#installation"},{"type":"extras","title":"Calling - Überauth Bexio","doc":"Depending on the configured url you can initiate the request through:\n\n    /auth/bexio\n\nOr with options:\n\n    /auth/bexio?scope=email%20profile\n\nBy default the requested scope is \"email\". Scope can be configured either explicitly as a `scope` query value on the request path or in your configuration:\n\n```elixir\nconfig :ueberauth, Ueberauth,\n  providers: [\n    bexio: {Ueberauth.Strategy.Bexio, [default_scope: \"openid email profile company_profile\"]}\n  ]\n```\n\nTODO: decide what we want to write here!\n\nTo guard against client-side request modification, it's important to still check the domain in `info.urls[:website]` within the `Ueberauth.Auth` struct if you want to limit sign-in to a specific domain.","ref":"readme.html#calling"},{"type":"extras","title":"Copyright and License - Überauth Bexio","doc":"Copyright (c) 2024 Smart Software Engineering SRL\n\nReleased under the MIT License, which can be found in the repository in [LICENSE](https://github.com/smart-software-engineering/ueberauth_bexio/blob/master/LICENSE).","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}